#pragma once

#include "libsyntax.h"
#include "ast_basic.h"


namespace ast_gen {
	
	/**
	* @brief ﷨
	*/
	class LIBSYNTAX_EXPORT SyntaxParser {
	private:
		std::shared_ptr<lib_syntax::IBasicRule> _rule_bind = nullptr;

	public:
		SyntaxParser(std::shared_ptr<lib_syntax::IBasicRule> rule);

		/**
		* @brief Դ﷨򣬽Դ
		* @param wods Դ
		* @return н·մ->
		*/
		QList<std::shared_ptr<const lib_syntax::MatchCursor>> parse(std::shared_ptr<lib_words::IPrimitiveWord> words);
		
		/**
		* @brief ָ·ȡ⹹
		* @param cursor ·
		* @param root ʽԤƸڵ
		* @return ƺĸڵ
		*/
		std::shared_ptr<ast_basic::IExprInstance> getAst(
			std::shared_ptr<const lib_syntax::MatchCursor> cursor, std::shared_ptr<ast_basic::IExprInstance> root);

	};



}